diff --git a/lib/hive/events.rb b/lib/hive/events.rb
index f8bca816..58883019 100644
--- a/lib/hive/events.rb
+++ b/lib/hive/events.rb
@@ -15,6 +15,7 @@ module Hive
       round_complete
       clean_exit_auto_committed
       claude_completion_fallback
+      auto_retry_decision
     ].freeze
 
     STATUS_TAIL_LINES = 20
@@ -46,7 +47,12 @@ module Hive
     # appenders via the inode lock; we cap message size (see
     # MAX_MESSAGE_BYTES) so the full line stays small and well-defined.
     # status.md is derived state and is rewritten with atomic rename.
-    def emit(task_folder:, slug:, stage:, event_type:, agent: nil, message: nil)
+    # Optional `details` is a bounded Hash of structured audit fields for
+    # auto-retry (and future) events. Existing base keys and the single-
+    # syswrite append contract are preserved; old readers ignore unknown keys.
+    MAX_DETAILS_BYTES = 2_048
+
+    def emit(task_folder:, slug:, stage:, event_type:, agent: nil, message: nil, details: nil)
       event_type = event_type.to_sym
       unless EVENT_TYPES.include?(event_type)
         raise ArgumentError, "unknown event_type #{event_type.inspect}; valid: #{EVENT_TYPES.inspect}"
@@ -60,6 +66,9 @@ module Hive
         "event_type" => event_type.to_s,
         "message" => message.nil? ? nil : truncate_message(message.to_s)
       }
+      if details.is_a?(Hash) && !details.empty?
+        record["details"] = bound_details(details)
+      end
 
       FileUtils.mkdir_p(task_folder)
       events_path = File.join(task_folder, "events.jsonl")
@@ -77,6 +86,43 @@ module Hive
       nil
     end
 
+    def bound_details(details)
+      # JSON-serialize and truncate so the full line stays under the append budget.
+      cleaned = details.each_with_object({}) do |(k, v), acc|
+        acc[k.to_s] = case v
+        when String, Numeric, TrueClass, FalseClass, NilClass then v
+        when Symbol then v.to_s
+        when Time then v.utc.iso8601
+        when Hash, Array then v
+        else v.to_s
+        end
+      end
+      raw = JSON.generate(cleaned)
+      return cleaned if raw.bytesize <= MAX_DETAILS_BYTES
+
+      bounded_preview(raw)
+    rescue StandardError
+      { "error" => "details_unserializable" }
+    end
+
+    def bounded_preview(raw)
+      low = 0
+      high = [ raw.bytesize, MAX_DETAILS_BYTES ].min
+      best = { "truncated" => true, "preview" => "" }
+      while low <= high
+        mid = (low + high) / 2
+        preview = raw.byteslice(0, mid).to_s.scrub("")
+        candidate = { "truncated" => true, "preview" => preview }
+        if JSON.generate(candidate).bytesize <= MAX_DETAILS_BYTES
+          best = candidate
+          low = mid + 1
+        else
+          high = mid - 1
+        end
+      end
+      best
+    end
+
     def truncate_message(message)
       return message if message.bytesize <= MAX_MESSAGE_BYTES
 
diff --git a/lib/hive/recovery_sequence.rb b/lib/hive/recovery_sequence.rb
new file mode 100644
index 00000000..cf3d9da9
--- /dev/null
+++ b/lib/hive/recovery_sequence.rb
@@ -0,0 +1,91 @@
+# frozen_string_literal: true
+
+require "hive/workflows"
+require "hive/workflows/project"
+require "hive/config"
+
+module Hive
+  # Daemon-neutral pure argv builder for marker-clear + same-stage retry.
+  # Extracted so bot recovery and daemon auto-retry emit byte-equivalent
+  # workflow verbs and --from/--stage scoping.
+  module RecoverySequence
+    module_function
+
+    # @return [Array<Array<String>>] ordered argvs: optional clear, then retry
+    def commands(project:, slug:, stage:, marker:, match_attr: nil, workflow: nil)
+      verb = retry_verb_for_stage(stage, workflow: workflow, project: project)
+      return [] unless verb
+
+      commands = []
+      marker_name = marker.to_s
+      unless marker_name.casecmp("none").zero? || marker_name.casecmp("agent_working").zero?
+        clear_argv = [ "hive", "markers", "clear", slug, "--name", marker_name.upcase,
+                       "--project", project ]
+        clear_argv += [ "--match-attr", match_attr ] if match_attr.to_s.include?("=")
+        clear_argv << "--json"
+        commands << clear_argv
+      end
+      stage_flag = verb == "run" ? "--stage" : "--from"
+      commands << [ "hive", verb, slug, stage_flag, stage, "--project", project, "--json" ]
+      commands
+    end
+
+    def retry_verb_for_stage(stage, workflow: nil, project: nil)
+      stage = stage.to_s
+      unless Hive::Workflows.coding_id?(workflow)
+        return nil if generic_terminal_stage?(stage, workflow, project: project)
+        return nil if generic_non_agent_stage?(stage, workflow, project: project)
+
+        return "run"
+      end
+      return nil if stage == "9-done" # coding-scoped: coding workflow terminal stage
+
+      # coding-scoped (block): legacy coding stage aliases
+      Hive::Workflows.verb_arriving_at(stage) || {
+        "5-review" => "review",
+        "6-pr" => "pr"
+      }[stage]
+    end
+
+    def match_attr_for_error(attrs)
+      require "hive/markers"
+      Hive::Markers.error_recovery_match_attr(attrs || {})
+    end
+
+    def generic_terminal_stage?(stage, workflow, project: nil)
+      descriptor = resolve_descriptor(workflow, project: project)
+      return false unless descriptor
+
+      last = descriptor.stages.last
+      !last.nil? && last.dir == stage
+    end
+    private_class_method :generic_terminal_stage?
+
+    def generic_non_agent_stage?(stage, workflow, project: nil)
+      descriptor = resolve_descriptor(workflow, project: project)
+      return false unless descriptor
+
+      found = descriptor.stage_for_dir(stage)
+      !found.nil? && found.kind != :agent
+    end
+    private_class_method :generic_non_agent_stage?
+
+    def resolve_descriptor(workflow, project: nil)
+      Hive::Workflows::Project.synchronize do
+        load_project_overlay(project)
+        Hive::Workflows::Registry.fetch(workflow.to_s.to_sym)
+      end
+    rescue Hive::Workflows::UnknownWorkflow
+      nil
+    end
+    private_class_method :resolve_descriptor
+
+    def load_project_overlay(project_name)
+      return if project_name.nil? || project_name.to_s.empty?
+
+      match = Hive::Config.registered_projects.find { |p| p["name"] == project_name.to_s }
+      Hive::Workflows::Project.load!(match["path"]) if match
+    end
+    private_class_method :load_project_overlay
+  end
+end
diff --git a/lib/hive/runtime_identity.rb b/lib/hive/runtime_identity.rb
new file mode 100644
index 00000000..b41416f5
--- /dev/null
+++ b/lib/hive/runtime_identity.rb
@@ -0,0 +1,64 @@
+# frozen_string_literal: true
+
+require "digest"
+require "hive"
+
+module Hive
+  # Canonical identity of the running hive process / CLI install.
+  # Shared by daemon re-exec drift detection and auto-retry Claude health
+  # probes so the two surfaces cannot disagree about "which code is live".
+  module RuntimeIdentity
+    module_function
+
+    # SHA-256 of the file that defines SCHEMA_VERSIONS (lib/hive.rb source
+    # location for Schemas helpers, matching Dispatcher#compute_code_fingerprint).
+    def code_fingerprint
+      path = Hive::Schemas.method(:schema_path).source_location.first
+      ::Digest::SHA256.file(path).hexdigest
+    rescue StandardError
+      nil
+    end
+
+    def version
+      Hive::VERSION.to_s
+    end
+
+    def binary_path(program_name: $PROGRAM_NAME, env: ENV)
+      require "hive/invoked_binary"
+      path = Hive::InvokedBinary.path(program_name: program_name, env: env)
+      return nil if path.nil?
+
+      File.realpath(path)
+    rescue SystemCallError
+      path
+    end
+
+    # Canonical, non-secret identity hash used as a health-fingerprint input.
+    def snapshot(program_name: $PROGRAM_NAME, env: ENV)
+      {
+        "version" => version,
+        "code_fingerprint" => code_fingerprint,
+        "binary_path" => binary_path(program_name: program_name, env: env)
+      }
+    end
+
+    def matches_cli?(cli_version:, cli_fingerprint:, cli_binary_path:,
+                     program_name: $PROGRAM_NAME, env: ENV)
+      snap = snapshot(program_name: program_name, env: env)
+      return false if snap["version"].to_s.empty? || cli_version.to_s.empty?
+      return false unless snap["version"].to_s == cli_version.to_s
+      return false if snap["code_fingerprint"].nil? || cli_fingerprint.to_s.empty?
+      return false unless snap["code_fingerprint"].to_s == cli_fingerprint.to_s
+
+      daemon_bin = snap["binary_path"].to_s
+      cli_bin = cli_binary_path.to_s
+      return false if daemon_bin.empty? || cli_bin.empty?
+
+      begin
+        File.realpath(daemon_bin) == File.realpath(cli_bin)
+      rescue SystemCallError
+        daemon_bin == cli_bin
+      end
+    end
+  end
+end
diff --git a/test/integration/daemon_auto_retry_test.rb b/test/integration/daemon_auto_retry_test.rb
new file mode 100644
index 00000000..e3831f3e
--- /dev/null
+++ b/test/integration/daemon_auto_retry_test.rb
@@ -0,0 +1,277 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "tmpdir"
+require "fileutils"
+require "json"
+require "hive/daemon/auto_retry/coordinator"
+require "hive/daemon/auto_retry/state"
+require "hive/daemon/auto_retry/health"
+require "hive/daemon/auto_retry/classifier"
+require "hive/daemon/status_consumer"
+require "hive/daemon/dispatch_request_queue"
+require "hive/config"
+
+# Hermetic acceptance paths for v1 health-gated auto-retry (task-58 /
+# task-287 style fixtures with fake health). No live provider calls.
+class DaemonAutoRetryIntegrationTest < Minitest::Test
+  Row = Hive::Daemon::StatusConsumer::Row
+
+  class FakeLogger
+    attr_reader :events
+    def initialize = @events = []
+    def event(name, **attrs) = @events << [ name, attrs ]
+  end
+
+  class FakeController
+    def running_task?(**) = false
+  end
+
+  class RecordingQueue
+    attr_reader :requests, :sequences
+    def initialize
+      @requests = []
+      @sequences = {}
+    end
+    def pending = []
+    def write_request!(**kwargs)
+      @requests << kwargs
+      kwargs[:request_id] || "req-#{@requests.size}"
+    end
+    def write_sequence!(id, remaining_argvs:, state_home: nil, recovery_id: nil)
+      @sequences[id] = { argvs: remaining_argvs, recovery_id: recovery_id }
+      true
+    end
+    def remove_if_unclaimed(*) = true
+  end
+
+  class ScriptedHealth
+    def initialize(results)
+      @results = results.dup
+    end
+    def reset_tick_cache!; end
+    def probe(**)
+      r = @results.shift || @results.last ||
+          Hive::Daemon::AutoRetry::Health::ProbeSetResult.new(
+            healthy: false, fingerprint: nil, probes: [], rationale: "done", correlation_id: "x"
+          )
+      r
+    end
+  end
+
+  def setup
+    @root = Dir.mktmpdir("hive-auto-retry-int")
+    @logger = FakeLogger.new
+    @queue = RecordingQueue.new
+    @state = Hive::Daemon::AutoRetry::State.new(path: File.join(@root, "daemon_auto_retry.json"))
+  end
+
+  def teardown
+    FileUtils.rm_rf(@root)
+  end
+
+  def make_worktree
+    wt = File.join(@root, "wt-#{SecureRandom.hex(3)}")
+    system("git", "init", "-q", wt, exception: true)
+    system("git", "-C", wt, "config", "user.email", "t@e.com", exception: true)
+    system("git", "-C", wt, "config", "user.name", "t", exception: true)
+    File.write(File.join(wt, "f"), "x\n")
+    system("git", "-C", wt, "add", "f", exception: true)
+    system("git", "-C", wt, "commit", "-qm", "i", exception: true)
+    wt
+  end
+
+  def make_task_row(reason:, message:, stage: "4-execute", agent_cfg: nil)
+    folder = File.join(@root, "tasks", "task-#{SecureRandom.hex(3)}")
+    FileUtils.mkdir_p(File.join(folder, "logs"))
+    File.write(File.join(folder, "logs", "agent.log"), "#{message}\n")
+    state = File.join(folder, "task.md")
+    File.write(state, "<!-- ERROR reason=#{reason} marker_id=mid42 message=#{message.inspect} -->\n")
+    wt = make_worktree
+    Row.new(
+      project: "demo",
+      slug: "task-slug-260601-abcd",
+      stage: stage,
+      workflow: "coding",
+      marker: "error",
+      marker_attrs: { "reason" => reason, "marker_id" => "mid42", "message" => message },
+      folder: folder,
+      state_file: state,
+      live_task_lock: false,
+      worktree_path: wt,
+      id: "58"
+    )
+  end
+
+  def coord(health_results:, enabled: true, cfg: nil)
+    cfg ||= { "execute" => { "agent" => "codex" }, "claude" => { "mode" => "tmux" } }
+    Hive::Daemon::AutoRetry::Coordinator.new(
+      logger: @logger,
+      controller: FakeController.new,
+      state: @state,
+      health: ScriptedHealth.new(health_results),
+      request_queue: @queue,
+      enabled: enabled,
+      config_for_project: ->(_) { cfg },
+      project_enabled: ->(_) { true },
+      legacy_projects: {}
+    )
+  end
+
+  def healthy(fp)
+    Hive::Daemon::AutoRetry::Health::ProbeSetResult.new(
+      healthy: true, fingerprint: fp, probes: [ { "name" => "ok", "ok" => true } ],
+      rationale: "healthy", correlation_id: "c"
+    )
+  end
+
+  def unhealthy
+    Hive::Daemon::AutoRetry::Health::ProbeSetResult.new(
+      healthy: false, fingerprint: nil, probes: [ { "name" => "login", "ok" => false } ],
+      rationale: "codex_login_unhealthy", correlation_id: "c"
+    )
+  end
+
+  def test_task58_style_parks_while_unhealthy_then_retries
+    row = make_task_row(
+      reason: "implementer_failed",
+      message: "unexpected status 401 Unauthorized: missing bearer authentication"
+    )
+    c = coord(health_results: [ unhealthy, healthy("fp-a") ])
+
+    c.tick([ row ], now: Time.utc(2026, 7, 17, 12, 0, 0))
+    assert_empty @queue.requests, "must not clear while login/smoke fail"
+
+    c.tick([ row ], now: Time.utc(2026, 7, 17, 12, 30, 0))
+    assert_equal 1, @queue.requests.size
+    assert_equal "auto_retry", @queue.requests.first[:requestor]
+    assert_includes @queue.requests.first[:argv], "markers"
+    assert_equal 1, @queue.sequences.size
+  end
+
+  def test_kill_switch_disables_all_actions
+    row = make_task_row(
+      reason: "implementer_failed",
+      message: "HTTP 401 Unauthorized missing bearer authentication"
+    )
+    c = coord(health_results: [ healthy("fp-a") ], enabled: false)
+    c.tick([ row ])
+    assert_empty @queue.requests
+  end
+
+  def test_second_failure_same_fingerprint_stays_parked
+    row = make_task_row(
+      reason: "implementer_failed",
+      message: "HTTP 401 Unauthorized missing bearer authentication"
+    )
+    c = coord(health_results: [ healthy("fp-a"), healthy("fp-a"), healthy("fp-a") ])
+
+    c.tick([ row ])
+    assert_equal 1, @queue.requests.size
+    # Simulate attempt accounted
+    record = @state.load_all.values.first
+    @state.upsert!(
+      project: "demo", task_key: "58", stage: "4-execute",
+      reason: "implementer_failed", phase: "retry_queued"
+    )
+    @state.mark_dispatched!(
+      project: "demo", task_key: "58", stage: "4-execute",
+      reason: "implementer_failed", fingerprint: "fp-a", recovery_id: record["recovery_id"]
+    )
+    @queue.requests.clear
+    @queue.sequences.clear
+
+    attrs = row.marker_attrs.merge("marker_id" => "mid43")
+    File.write(row.state_file, "<!-- ERROR reason=implementer_failed marker_id=mid43 message=\"HTTP 401 Unauthorized missing bearer authentication\" -->\n")
+    failed_row = Row.new(**row.to_h.merge(marker_attrs: attrs))
+    c.tick([ failed_row ])
+    assert_equal "failed", @state.load_all.values.first["phase"]
+    c.tick([ failed_row ])
+    assert_empty @queue.requests, "unchanged fingerprint must not re-queue"
+  end
+
+  def test_claude_launcher_task287_style
+    row = make_task_row(
+      reason: "claude_launch_failed",
+      message: "claude interactive prompt did not become ready in tmux session x",
+      stage: "3-plan"
+    )
+    File.write(File.join(row.folder, "plan.md"), "<!-- ERROR reason=claude_launch_failed marker_id=mid42 -->\n")
+    cfg = {
+      "execute" => { "agent" => "claude" },
+      "plan" => { "agent" => "claude" },
+      "claude" => { "mode" => "tmux" }
+    }
+    c = coord(health_results: [ healthy("fp-claude") ], cfg: cfg)
+    c.tick([ row ])
+    assert_equal 1, @queue.requests.size
+  end
+
+  def test_dirty_worktree_never_clears
+    row = make_task_row(
+      reason: "implementer_failed",
+      message: "HTTP 401 Unauthorized missing bearer authentication"
+    )
+    File.write(File.join(row.worktree_path, "dirty"), "user edit\n")
+    c = coord(health_results: [ healthy("fp-a") ])
+    c.tick([ row ])
+    assert_empty @queue.requests
+  end
+
+  def test_classifier_rejects_generic_exit_1
+    result = Hive::Daemon::AutoRetry::Classifier.classify(
+      row: {
+        marker: "error",
+        marker_attrs: { "reason" => "exit_code", "exit_code" => "1" },
+        stage: "4-execute"
+      },
+      config: { "execute" => { "agent" => "codex" } },
+      evidence: { text: "exit 1", kind: :log, fresh: true, marker_signature_match: true },
+      execute_agent: "codex"
+    )
+    refute result.eligible?
+  end
+
+  def test_real_queue_recovers_markerless_crash_window_after_restart
+    row = make_task_row(
+      reason: "implementer_failed",
+      message: "HTTP 401 Unauthorized: missing bearer authentication"
+    )
+    old_home = ENV["HIVE_HOME"]
+    ENV["HIVE_HOME"] = @root
+    real_state = Hive::Daemon::AutoRetry::State.new(path: File.join(@root, "real-state.json"))
+    build = lambda do
+      Hive::Daemon::AutoRetry::Coordinator.new(
+        logger: @logger,
+        controller: FakeController.new,
+        state: real_state,
+        health: ScriptedHealth.new([ healthy("fp-real") ]),
+        request_queue: Hive::Daemon::DispatchRequestQueue,
+        enabled: true,
+        config_for_project: ->(_) { { "execute" => { "agent" => "codex" } } },
+        project_enabled: ->(_) { true },
+        legacy_projects: {}
+      )
+    end
+
+    build.call.tick([ row ])
+    record = real_state.load_all.values.first
+    clear_id = record["clear_request_id"]
+    assert Hive::Daemon::DispatchRequestQueue.request_exists?(clear_id, state_home: @root)
+
+    Hive::Daemon::DispatchRequestQueue.remove(clear_id, state_home: @root)
+    real_state.upsert!(project: record["project"], task_key: record["task_key"],
+                       stage: record["stage"], reason: record["reason"], phase: "marker_cleared")
+    File.write(row.state_file, "")
+    markerless = Row.new(**row.to_h.merge(marker: "none", marker_attrs: {}))
+
+    build.call.tick([ markerless ])
+
+    pending = Hive::Daemon::DispatchRequestQueue.pending(state_home: @root)
+    assert_equal 1, pending.size
+    assert_equal "rerun", pending.first.recovery_step
+    assert_equal record["recovery_id"], pending.first.recovery_id
+  ensure
+    old_home.nil? ? ENV.delete("HIVE_HOME") : ENV["HIVE_HOME"] = old_home
+  end
+end
diff --git a/test/integration/gem_package_scripts_test.rb b/test/integration/gem_package_scripts_test.rb
index ff2ba7e5..b79a2c4c 100644
--- a/test/integration/gem_package_scripts_test.rb
+++ b/test/integration/gem_package_scripts_test.rb
@@ -2,6 +2,7 @@ require "test_helper"
 require "open3"
 require "rubygems/package"
 require "tmpdir"
+require "rbconfig"
 
 class GemPackageScriptsTest < Minitest::Test
   ROOT = File.expand_path("../..", __dir__)
@@ -33,6 +34,30 @@ class GemPackageScriptsTest < Minitest::Test
       referenced_scripts.each do |path|
         assert_includes packaged_files, path
       end
+
+
+      extracted = File.join(dir, "installed")
+      FileUtils.mkdir_p(extracted)
+      Gem::Package.new(gem_path).extract_files(extracted)
+      check = <<~'RUBY'
+        require "json"
+        require "hive/claude_launcher"
+        wrapper = Hive::ClaudeLauncher.interactive_wrapper_path
+        puts JSON.generate(
+          wrapper_exists: File.file?(wrapper),
+          wrapper_executable: File.executable?(wrapper),
+          readiness: Hive::ClaudeLauncher.readiness_detector_self_check
+        )
+      RUBY
+      out, err, installed_status = Open3.capture3(
+        RbConfig.ruby, "-I#{File.join(extracted, 'lib')}", "-e", check,
+        chdir: extracted
+      )
+      assert installed_status.success?, "installed package readiness failed: #{err}"
+      readiness = JSON.parse(out)
+      assert_equal true, readiness["wrapper_exists"]
+      assert_equal true, readiness["wrapper_executable"]
+      assert_equal true, readiness.dig("readiness", "ok")
     end
   end
 
diff --git a/test/integration/markers_command_test.rb b/test/integration/markers_command_test.rb
index 19e14bfe..8b89e4a5 100644
--- a/test/integration/markers_command_test.rb
+++ b/test/integration/markers_command_test.rb
@@ -3,6 +3,7 @@ require "json"
 require "hive/commands/init"
 require "hive/commands/new"
 require "hive/commands/markers"
+require "hive/daemon/auto_retry/state"
 
 # Integration coverage for `hive markers clear FOLDER --name <NAME>`.
 #
@@ -411,6 +412,30 @@ class MarkersCommandTest < Minitest::Test
     [ project, review, File.basename(review) ]
   end
 
+  def seed_plan_auto_retry(dir)
+    capture_io { Hive::Commands::Init.new(dir).call }
+    project = File.basename(dir)
+    capture_io { Hive::Commands::New.new(project, "auto retry marker probe").call }
+    inbox = Dir[File.join(dir, ".hive-state", "stages", "1-inbox", "*")].first
+    plan = File.join(dir, ".hive-state", "stages", "3-plan", File.basename(inbox))
+    FileUtils.mkdir_p(File.dirname(plan))
+    FileUtils.mv(inbox, plan)
+    task = Hive::Task.new(plan)
+    File.write(task.state_file, "")
+    Hive::Markers.set(
+      task.state_file, :error,
+      reason: "claude_launch_failed",
+      message: "claude interactive prompt did not become ready"
+    )
+    recovery_id = "ar-marker-command"
+    Hive::Daemon::AutoRetry::State.new.upsert!(
+      project: project, task_key: task.id.to_s, stage: "3-plan",
+      reason: "claude_launch_failed", phase: "clear_queued",
+      recovery_id: recovery_id
+    )
+    [ project, plan, task, recovery_id ]
+  end
+
   def test_match_attr_clears_when_value_matches
     with_tmp_global_config do
       with_tmp_git_repo do |dir|
@@ -427,6 +452,82 @@ class MarkersCommandTest < Minitest::Test
         marker = Hive::Markers.current(state)
         assert_equal :none, marker.name,
                      "matching --match-attr value must allow the clear"
+        audit = File.readlines(File.join(folder, "events.jsonl"), chomp: true)
+                    .map { |line| JSON.parse(line) }
+                    .find { |event| event["event_type"] == "auto_retry_decision" }
+        refute_nil audit
+        assert_equal "manual_rearm", audit.dig("details", "action")
+        assert_equal "manual_clear", audit.dig("details", "rationale")
+      end
+    end
+  end
+
+  def test_manual_clear_keeps_marker_when_retry_ledger_cannot_rearm
+    with_tmp_global_config do
+      with_tmp_git_repo do |dir|
+        _, folder, _slug = seed_error_with_attrs(
+          dir, marker_attrs: { reason: "exit_code", exit_code: 143 }
+        )
+        state_file = File.join(folder, "task.md")
+        failing_state = Object.new
+        failing_state.define_singleton_method(:rearm_manual!) do |**|
+          raise Hive::Daemon::AutoRetry::State::Suspended, "disk unavailable"
+        end
+
+        _out, _err, status = with_replaced_singleton_method(
+          Hive::Daemon::AutoRetry::State, :new, ->(**) { failing_state }
+        ) do
+          with_captured_exit do
+            Hive::Commands::Markers.new(
+              "clear", folder, name: "ERROR", match_attr: "exit_code=143"
+            ).call
+          end
+        end
+
+        assert_equal Hive::ExitCodes::SOFTWARE, status
+        assert_equal :error, Hive::Markers.current(state_file).name
+      end
+    end
+  end
+
+  def test_automatic_clear_advances_ledger_before_removing_marker
+    with_tmp_global_config do
+      with_tmp_git_repo do |dir|
+        project, folder, task, recovery_id = seed_plan_auto_retry(dir)
+
+        capture_io do
+          Hive::Commands::Markers.new(
+            "clear", folder, name: "ERROR", recovery_id: recovery_id
+          ).call
+        end
+
+        assert_equal :none, Hive::Markers.current(task.state_file).name
+        record = Hive::Daemon::AutoRetry::State.new.get(
+          project: project, task_key: task.id.to_s, stage: "3-plan",
+          reason: "claude_launch_failed"
+        )
+        assert_equal "marker_cleared", record["phase"]
+        assert_equal recovery_id, record["recovery_id"]
+      end
+    end
+  end
+
+  def test_automatic_clear_rechecks_global_kill_switch
+    with_tmp_global_config do |home|
+      with_tmp_git_repo do |dir|
+        _project, folder, task, recovery_id = seed_plan_auto_retry(dir)
+        global = YAML.safe_load(File.read(File.join(home, "config.yml")))
+        global["daemon"] = { "auto_retry" => { "enabled" => false } }
+        File.write(File.join(home, "config.yml"), global.to_yaml)
+
+        _out, _err, status = with_captured_exit do
+          Hive::Commands::Markers.new(
+            "clear", folder, name: "ERROR", recovery_id: recovery_id
+          ).call
+        end
+
+        assert_equal Hive::ExitCodes::WRONG_STAGE, status
+        assert_equal :error, Hive::Markers.current(task.state_file).name
       end
     end
   end
diff --git a/test/unit/cli_test.rb b/test/unit/cli_test.rb
index dafa1c29..42374d47 100644
--- a/test/unit/cli_test.rb
+++ b/test/unit/cli_test.rb
@@ -62,6 +62,20 @@ class HiveCliTest < Minitest::Test
 
     out, _err = capture_io { Hive::CLI.start([ "version" ]) }
     assert_equal "#{Hive::VERSION}\n", out
+
+    json_out, _json_err = capture_io { Hive::CLI.start([ "version", "--json" ]) }
+    identity = JSON.parse(json_out)
+    assert_equal Hive::VERSION, identity["version"]
+    assert_equal Hive::RuntimeIdentity.code_fingerprint, identity["code_fingerprint"]
+    assert identity.key?("binary_path")
+  end
+
+  def test_runtime_identity_rejects_missing_cli_or_daemon_path
+    refute Hive::RuntimeIdentity.matches_cli?(
+      cli_version: Hive::RuntimeIdentity.version,
+      cli_fingerprint: Hive::RuntimeIdentity.code_fingerprint,
+      cli_binary_path: nil
+    )
   end
 
   def test_init_forget_prune_update_uninstall_and_migrate_pass_options
diff --git a/test/unit/commands/doctor_test.rb b/test/unit/commands/doctor_test.rb
index 946169f2..a593170a 100644
--- a/test/unit/commands/doctor_test.rb
+++ b/test/unit/commands/doctor_test.rb
@@ -263,6 +263,29 @@ class HiveCommandsDoctorTest < Minitest::Test
     end
   end
 
+  def test_required_agent_rows_accepts_prebounded_dependency_without_cli_probe
+    with_fake_home do |home|
+      install_brainstorm_and_plan_skills(home)
+      dependency = {
+        kind: "dependency", stage: "claude", label: "claude/tmux",
+        agent: "tmux", configured_skill: "tmux >= 3.0", skill: "tmux",
+        status: "present", message: "bounded probe"
+      }
+      cfg = base_config("claude" => { "mode" => "tmux" })
+
+      rows = with_replaced_singleton_method(
+        Hive::ClaudeLauncher, :tmux_status, -> { raise "must not run" }
+      ) do
+        Hive::Commands::Doctor.required_agent_rows(
+          config: cfg, project_root: nil, dependency_rows: [ dependency ]
+        )
+      end
+
+      assert_equal dependency, rows.first
+      assert_equal %w[brainstorm plan], rows.drop(1).map { |row| row[:stage] }
+    end
+  end
+
   def test_tmux_dependency_row_fails_when_global_tmux_mode_cannot_run_tmux
     with_fake_home do |home|
       write_file("#{home}/.claude/plugins/cache/mp/compound-engineering/3.0.1/skills/ce-brainstorm/SKILL.md")
